mod\_logio

Logging of input and output bytes per request

Extension

mod\_logio.c

logio\_module

This module provides the logging of input and output number of bytes
received/sent per request. The numbers reflect the actual bytes as
received on the network, which then takes into account the headers and
bodies of requests and responses. The counting is done before SSL/TLS on
input and after SSL/TLS on output, so the numbers will correctly reflect
any changes made by encryption.

This module requires

mod\_log\_config

.

> **Note**
>
> When KeepAlive connections are used with SSL, the overhead of the SSL
> handshake is reflected in the byte count of the first request on the
> connection. When per-directory SSL renegotiation occurs, the bytes are
> associated with the request that triggered the renegotiation.

mod\_log\_config

Apache Log Files

Custom Log Formats {#formats}
==================

This module adds three new logging directives. The characteristics of
the request itself are logged by placing \"

\%

\" directives in the format string, which are replaced in the log file
by the values as follows:

  --------------- --------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  Format String   Description

  `%I`            Bytes received, including request and headers, cannot be zero.

  `%O`            Bytes sent, including headers, cannot be zero.

  `%S`            Bytes transferred (received and sent), including request and headers, cannot be zero. This is the combination of %I and %O.\
                  Available in Apache 2.4.7 and later

  `%^FU`          Delay in microseconds between when the request arrived and the last byte of the request body was read (finished upload). Only available if LogIOTrackTTFU is set to ON.\
                  Available in Apache 2.4.34 and later

  `%^FB`          Delay in microseconds between when the request arrived and the first byte of the response headers are written. Only available if LogIOTrackTTFB is set to ON.\
                  Available in Apache 2.4.13 and later
  --------------- --------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Usually, the functionality is used like this:

Combined I/O log format:

\"%h %l %u %t \\\"%r\\\" %\>s %b \\\"%{Referer}i\\\"
\\\"%{User-agent}i\\\" %I %O\"

LogIOTrackTTFU

Enable tracking of time to last request byte (TTFU = time to finish
upload)

LogIOTrackTTFU ON\|OFF

LogIOTrackTTFU OFF

server config

virtual host

directory

.htaccess

All

Apache HTTP Server 2.4.34 and later

This directive configures whether this module tracks the delay between
the request being read and the last byte of the request body being read
(finished upload). The resulting value may be logged with the

\%\^FU

format.

LogIOTrackTTFB

Enable tracking of time to first byte (TTFB = time to first byte)

LogIOTrackTTFB ON\|OFF

LogIOTrackTTFB OFF

server config

virtual host

directory

.htaccess

All

Apache HTTP Server 2.4.13 and later

This directive configures whether this module tracks the delay between
the request being read and the first byte of the response headers being
written. The resulting value may be logged with the

\%\^FB

format.
