mod\_slotmem\_shm

Slot-based shared memory provider.

Extension

mod\_slotmem\_shm.c

slotmem\_shm\_module

mod\_slotmem\_shm

is a memory provider which provides for creation and access to a shared
memory segment in which the datasets are organized in \"slots.\"

All shared memory is cleared and cleaned with each restart, whether
graceful or not. The data itself is stored and restored within a file
noted by the

name

parameter in the

create

and

attach

calls. If not specified with an absolute path, the file will be created
relative to the path specified by the

DefaultRuntimeDir

directive.

mod\_slotmem\_shm

provides the following API functions:

/\* call the callback on all worker slots \*/ apr\_status\_t
doall(ap\_slotmem\_instance\_t \*s, ap\_slotmem\_callback\_fn\_t \*func,
void \*data, apr\_pool\_t \*pool) /\* create a new slotmem with each
item size is item\_size. \'name\' is used to generate a filename for the
persistent store of the shared memory if configured. Values are:
\"none\" - Anonymous shared memory and no persistent store \"file-name\"
- \[DefaultRuntimeDir\]/file-name \"/absolute-file-name\" - Absolute
file name \*/ apr\_status\_t create(ap\_slotmem\_instance\_t \*\*new,
const char \*name, apr\_size\_t item\_size, unsigned int item\_num,
ap\_slotmem\_type\_t type, apr\_pool\_t \*pool) /\* attach to an
existing slotmem. See \'create()\' for description of \'name\' parameter
\*/ apr\_status\_t attach(ap\_slotmem\_instance\_t \*\*new, const char
\*name, apr\_size\_t \*item\_size, unsigned int \*item\_num,
apr\_pool\_t \*pool) /\* get the direct pointer to the memory associated
with this worker slot \*/ apr\_status\_t dptr(ap\_slotmem\_instance\_t
\*s, unsigned int item\_id, void \*\*mem) /\* get/read the memory from
this slot to dest \*/ apr\_status\_t get(ap\_slotmem\_instance\_t \*s,
unsigned int item\_id, unsigned char \*dest, apr\_size\_t dest\_len) /\*
put/write the data from src to this slot \*/ apr\_status\_t
put(ap\_slotmem\_instance\_t \*slot, unsigned int item\_id, unsigned
char \*src, apr\_size\_t src\_len) /\* return the total number of slots
in the segment \*/ unsigned int num\_slots(ap\_slotmem\_instance\_t \*s)
/\* return the total data size, in bytes, of a slot in the segment \*/
apr\_size\_t slot\_size(ap\_slotmem\_instance\_t \*s) /\* grab or
allocate the first free slot and mark as in-use (does not do any data
copying) \*/ apr\_status\_t grab(ap\_slotmem\_instance\_t \*s, unsigned
int \*item\_id) /\* forced grab or allocate the specified slot and mark
as in-use (does not do any data copying) \*/ apr\_status\_t
fgrab(ap\_slotmem\_instance\_t \*s, unsigned int item\_id) /\* release
or free a slot and mark as not in-use (does not do any data copying) \*/
apr\_status\_t release(ap\_slotmem\_instance\_t \*s, unsigned int
item\_id)
